import axios from 'axios'; // import getPerf from '@s-ui/perf'
// import measureAxios from '@s-ui/perf/src/measure-axios'

/** @typedef {import('./FetcherInterface').default} FetcherInterface */

/** @implements {FetcherInterface} */

var AxiosFetcher = /*#__PURE__*/function () {
  /**
   * @param {object} deps
   * @param {object} deps.config
   */
  function AxiosFetcher(_ref) {
    var config = _ref.config;
    this._axios = axios.create(config); // const perf = getPerf(config.get('serverRequestId') || 'default')
    // measureAxios(perf)(this._axios)
  }
  /**
   * Get method
   * @param {String} url
   * @param {Object} options
   * @return {Promise<any>}
   */


  var _proto = AxiosFetcher.prototype;

  _proto.get = function get(url, options) {
    return this._axios.get(url, options);
  }
  /**
   * Post method
   * @method post
   * @param {String} url
   * @param {String} body
   * @param {Object} options
   * @return {Promise}
   */
  ;

  _proto.post = function post(url, body, options) {
    return this._axios.post(url, body, options);
  }
  /**
   * Put method
   * @method put
   * @param {String} url
   * @param {String} body
   * @param {Object} options
   * @return {Object}
   */
  ;

  _proto.put = function put(url, body, options) {
    return this._axios.put(url, body, options);
  }
  /**
   * Patch method
   * @method patch
   * @param {String} url
   * @param {String} body
   * @param {Object} options
   * @return {Object}
   */
  ;

  _proto.patch = function patch(url, body, options) {
    return this._axios.patch(url, body, options);
  }
  /**
   * Delete method
   * @method delete
   * @param {String} url
   * @param {Object} options
   * @return {Object}
   */
  ;

  _proto["delete"] = function _delete(url, options) {
    return this._axios["delete"](url, options);
  };

  return AxiosFetcher;
}();

export { AxiosFetcher as default };